package com.ycwl.basic.storage.starter;

import com.ycwl.basic.storage.StorageFactory;
import com.ycwl.basic.storage.adapters.IStorageAdapter;
import com.ycwl.basic.storage.starter.config.OverallStorageConfig;
import org.springframework.context.annotation.Configuration;

import java.util.Map;

@Configuration
public class StorageAutoConfiguration {
    private final OverallStorageConfig config;
    public StorageAutoConfiguration(OverallStorageConfig config) {
        this.config = config;
        if (config != null) {
            loadConfig();
        }
    }

    private void loadConfig() {
        config.getConfigs().forEach(item -> {
            String name = item.getName();
            String type = item.getType();
            IStorageAdapter adapter = StorageFactory.get(type);
            Map<String, String> config = item.getConfig();
            adapter.loadConfig(config);
            StorageFactory.register(name, adapter);
        });
    }
}
